# This file was auto-generated by Fern from our API Definition.

from ..core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .configurations.client import AsyncConfigurationsClient, ConfigurationsClient
from .incidents.client import AsyncIncidentsClient, IncidentsClient
from .raw_client import AsyncRawAlertsClient, RawAlertsClient


class AlertsClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawAlertsClient(client_wrapper=client_wrapper)
        self.configurations = ConfigurationsClient(client_wrapper=client_wrapper)

        self.incidents = IncidentsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawAlertsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawAlertsClient
        """
        return self._raw_client


class AsyncAlertsClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawAlertsClient(client_wrapper=client_wrapper)
        self.configurations = AsyncConfigurationsClient(client_wrapper=client_wrapper)

        self.incidents = AsyncIncidentsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawAlertsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawAlertsClient
        """
        return self._raw_client
