# This file was auto-generated by Fern from our API Definition.

from ..core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .media.client import AsyncMediaClient, MediaClient
from .raw_client import AsyncRawCamerasClient, RawCamerasClient


class CamerasClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawCamerasClient(client_wrapper=client_wrapper)
        self.media = MediaClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawCamerasClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawCamerasClient
        """
        return self._raw_client


class AsyncCamerasClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawCamerasClient(client_wrapper=client_wrapper)
        self.media = AsyncMediaClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawCamerasClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawCamerasClient
        """
        return self._raw_client
