# This file was auto-generated by Fern from our API Definition.

from ..core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .driver_coach_assignments.client import AsyncDriverCoachAssignmentsClient, DriverCoachAssignmentsClient
from .raw_client import AsyncRawCoachingClient, RawCoachingClient
from .sessions.client import AsyncSessionsClient, SessionsClient


class CoachingClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawCoachingClient(client_wrapper=client_wrapper)
        self.driver_coach_assignments = DriverCoachAssignmentsClient(client_wrapper=client_wrapper)

        self.sessions = SessionsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawCoachingClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawCoachingClient
        """
        return self._raw_client


class AsyncCoachingClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawCoachingClient(client_wrapper=client_wrapper)
        self.driver_coach_assignments = AsyncDriverCoachAssignmentsClient(client_wrapper=client_wrapper)

        self.sessions = AsyncSessionsClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawCoachingClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawCoachingClient
        """
        return self._raw_client
