# This file was auto-generated by Fern from our API Definition.

from ..core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .drivers.client import AsyncDriversClient, DriversClient
from .ifta.client import AsyncIftaClient, IftaClient
from .raw_client import AsyncRawReportsClient, RawReportsClient
from .vehicles.client import AsyncVehiclesClient, VehiclesClient


class ReportsClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawReportsClient(client_wrapper=client_wrapper)
        self.drivers = DriversClient(client_wrapper=client_wrapper)

        self.ifta = IftaClient(client_wrapper=client_wrapper)

        self.vehicles = VehiclesClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawReportsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawReportsClient
        """
        return self._raw_client


class AsyncReportsClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawReportsClient(client_wrapper=client_wrapper)
        self.drivers = AsyncDriversClient(client_wrapper=client_wrapper)

        self.ifta = AsyncIftaClient(client_wrapper=client_wrapper)

        self.vehicles = AsyncVehiclesClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawReportsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawReportsClient
        """
        return self._raw_client
