# This file was auto-generated by Fern from our API Definition.

from ...core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .fuel_energy.client import AsyncFuelEnergyClient, FuelEnergyClient
from .raw_client import AsyncRawDriversClient, RawDriversClient


class DriversClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawDriversClient(client_wrapper=client_wrapper)
        self.fuel_energy = FuelEnergyClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawDriversClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawDriversClient
        """
        return self._raw_client


class AsyncDriversClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawDriversClient(client_wrapper=client_wrapper)
        self.fuel_energy = AsyncFuelEnergyClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawDriversClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawDriversClient
        """
        return self._raw_client
