# This file was auto-generated by Fern from our API Definition.

from ..core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .compliance.client import AsyncComplianceClient, ComplianceClient
from .driver_app.client import AsyncDriverAppClient, DriverAppClient
from .raw_client import AsyncRawSettingsClient, RawSettingsClient
from .safety.client import AsyncSafetyClient, SafetyClient


class SettingsClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawSettingsClient(client_wrapper=client_wrapper)
        self.compliance = ComplianceClient(client_wrapper=client_wrapper)

        self.driver_app = DriverAppClient(client_wrapper=client_wrapper)

        self.safety = SafetyClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawSettingsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawSettingsClient
        """
        return self._raw_client


class AsyncSettingsClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawSettingsClient(client_wrapper=client_wrapper)
        self.compliance = AsyncComplianceClient(client_wrapper=client_wrapper)

        self.driver_app = AsyncDriverAppClient(client_wrapper=client_wrapper)

        self.safety = AsyncSafetyClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawSettingsClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawSettingsClient
        """
        return self._raw_client
