# This file was auto-generated by Fern from our API Definition.

from ..core.client_wrapper import AsyncClientWrapper, SyncClientWrapper
from .driver.client import AsyncDriverClient, DriverClient
from .raw_client import AsyncRawTachographClient, RawTachographClient
from .vehicles.client import AsyncVehiclesClient, VehiclesClient


class TachographClient:
    def __init__(self, *, client_wrapper: SyncClientWrapper):
        self._raw_client = RawTachographClient(client_wrapper=client_wrapper)
        self.driver = DriverClient(client_wrapper=client_wrapper)

        self.vehicles = VehiclesClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> RawTachographClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        RawTachographClient
        """
        return self._raw_client


class AsyncTachographClient:
    def __init__(self, *, client_wrapper: AsyncClientWrapper):
        self._raw_client = AsyncRawTachographClient(client_wrapper=client_wrapper)
        self.driver = AsyncDriverClient(client_wrapper=client_wrapper)

        self.vehicles = AsyncVehiclesClient(client_wrapper=client_wrapper)

    @property
    def with_raw_response(self) -> AsyncRawTachographClient:
        """
        Retrieves a raw implementation of this client that returns raw responses.

        Returns
        -------
        AsyncRawTachographClient
        """
        return self._raw_client
