# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
import typing_extensions
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from ..core.serialization import FieldMetadata
from .defect_resolved_by import DefectResolvedBy
from .dvir_trailer_defects_items_trailer import DvirTrailerDefectsItemsTrailer
from .dvir_trailer_defects_items_vehicle import DvirTrailerDefectsItemsVehicle


class DvirTrailerDefectsItems(UniversalBaseModel):
    comment: typing.Optional[str] = pydantic.Field(default=None)
    """
    Comment on the defect.
    """

    created_at_time: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="createdAtTime")] = (
        pydantic.Field(default=None)
    )
    """
    Time when the defect was created. UTC timestamp in RFC 3339 format. Example: `2020-01-27T07:06:25Z`.
    """

    defect_type: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="defectType")] = pydantic.Field(
        default=None
    )
    """
    The type of DVIR defect.
    """

    id: str = pydantic.Field()
    """
    ID of the defect.
    """

    is_resolved: typing_extensions.Annotated[bool, FieldMetadata(alias="isResolved")] = pydantic.Field()
    """
    Signifies if this defect is resolved.
    """

    mechanic_notes: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="mechanicNotes")] = (
        pydantic.Field(default=None)
    )
    """
    The mechanics notes on the defect.
    """

    mechanic_notes_updated_at_time: typing_extensions.Annotated[
        typing.Optional[str], FieldMetadata(alias="mechanicNotesUpdatedAtTime")
    ] = pydantic.Field(default=None)
    """
    Time when mechanic notes were last updated. UTC timestamp in RFC 3339 format. Example: `2020-01-27T07:06:25Z`.
    """

    resolved_at_time: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="resolvedAtTime")] = (
        pydantic.Field(default=None)
    )
    """
    Time when this defect was resolved. Will not be returned if the defect is unresolved. UTC timestamp in RFC 3339 format. Example: `2020-01-27T07:06:25Z`.
    """

    resolved_by: typing_extensions.Annotated[typing.Optional[DefectResolvedBy], FieldMetadata(alias="resolvedBy")] = (
        None
    )
    trailer: typing.Optional[DvirTrailerDefectsItemsTrailer] = None
    vehicle: typing.Optional[DvirTrailerDefectsItemsVehicle] = None

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
