# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
import typing_extensions
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from ..core.serialization import FieldMetadata
from .unit_response_body_base_unit import UnitResponseBodyBaseUnit
from .unit_response_body_measurement_type import UnitResponseBodyMeasurementType


class UnitResponseBody(UniversalBaseModel):
    """
    Unit information
    """

    base_unit: typing_extensions.Annotated[
        typing.Optional[UnitResponseBodyBaseUnit], FieldMetadata(alias="baseUnit")
    ] = pydantic.Field(default=None)
    """
    Unit of measurement  Valid values: `bar`, `celsius`, `fahrenheit`, `foot`, `gallon`, `galpermi`, `gforce`, `gperliter`, `gperm`, `hour`, `impgallon`, `impgalpermi`, `inch`, `kelvin`, `kgper100kmgaseousfuel`, `kgpergallon`, `kgperkm`, `kgperliter`, `kgpermi`, `kilogram`, `kilogramgaseousfuel`, `kilometer`, `kilopascal`, `kilowatthour`, `kmperhr`, `lbpermi`, `liter`, `litergaseousfuel`, `lper100km`, `lper100kmgaseousfuel`, `lperkm`, `lperm`, `meter`, `meterspersec`, `mile`, `milliknot`, `millisecond`, `millivolt`, `mipergal`, `miperhr`, `miperimpgal`, `mpgusgalgaseousfuel`, `mpkggaseousfuel`, `percent`, `pound`, `poundsPerSquareInch`, `poundspergallon`, `poundsperliter`, `second`, `usd`, `usgallongaseousfuel`, `volt`, `watthour`
    """

    measurement_type: typing_extensions.Annotated[
        typing.Optional[UnitResponseBodyMeasurementType], FieldMetadata(alias="measurementType")
    ] = pydantic.Field(default=None)
    """
    Type of measurement  Valid values: `acceleration`, `co2EmissionsPerVolumeRate`, `currency`, `distance`, `drySpreadRate`, `duration`, `energy`, `fuelEconomy`, `gaseousFuel`, `gaseousFuelEconomy`, `pressure`, `ratio`, `speed`, `temperature`, `time`, `voltage`, `volume`, `weight`, `wetSpreadRate`
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
