# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic
import typing_extensions
from ..core.pydantic_utilities import IS_PYDANTIC_V2, UniversalBaseModel
from ..core.serialization import FieldMetadata
from .vehicle_response_response_body_asset_type import VehicleResponseResponseBodyAssetType


class VehicleResponseResponseBody(UniversalBaseModel):
    """
    A vehicle object
    """

    asset_type: typing_extensions.Annotated[
        typing.Optional[VehicleResponseResponseBodyAssetType], FieldMetadata(alias="assetType")
    ] = pydantic.Field(default=None)
    """
    The type of the asset.  Valid values: `uncategorized`, `trailer`, `equipment`, `unpowered`, `vehicle`
    """

    external_ids: typing_extensions.Annotated[
        typing.Optional[typing.Dict[str, str]], FieldMetadata(alias="externalIds")
    ] = pydantic.Field(default=None)
    """
    A map of external ids
    """

    id: typing.Optional[str] = pydantic.Field(default=None)
    """
    ID of the vehicle
    """

    license_plate: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="licensePlate")] = (
        pydantic.Field(default=None)
    )
    """
    The license plate of the vehicle.
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    Name of the vehicle
    """

    vehicle_vin: typing_extensions.Annotated[typing.Optional[str], FieldMetadata(alias="vehicleVin")] = pydantic.Field(
        default=None
    )
    """
    The VIN of the vehicle.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
